# TODO:
# - BUG: you can't set in /etc/mdadm.conf:
#  DEVICE partitions containers
#  (which is default BTW if none set). Generation of initrd will fail
#
Summary:	Creates an initial ramdisk image for preloading modules
Summary(pl.UTF-8):	Narzędzie do tworzenia inicjalnego ramdysku używanego przy starcie systemu
Name:		geninitrd
Version:	12749
Release:	3
License:	GPL
Group:		Applications/System
Source0:	%{name}-%{version}.tar.gz
# Source0-md5:	f26733e51d545d71feff72c16abf1f6b
Patch0:		%{name}-git.patch
URL:		http://git.pld-linux.org/?p=projects/geninitrd.git
BuildRequires:	xmlto >= 0:0.0.18-1
Requires:	/usr/bin/ldd
Requires:	awk
Requires:	busybox-initrd >= 1.22.1-2
Requires:	coreutils
Requires:	cpio
Requires:	fileutils
Requires:	glibc-misc
Requires:	gzip
Requires:	mktemp >= 1.5-8
Requires:	mount
Requires:	pci-database >= 0.4
Requires:	rc-scripts >= 0.2.7
Requires:	tar
Requires:	virtual(module-tools)
Requires:	xz
Suggests:	genromfs
Suggests:	pciutils
Obsoletes:	mkinitrd
# suggest for blkid
%if "%{pld_release}" == "ac"
# otherwise LVM subsystem is not enabled in geninitrd
Suggests:	lvm2-initrd
# without this softraid installations of PLD fail
Suggests:	mdadm-initrd >= 1.12.0-1
Conflicts:	grubby < 5.0.4-3.1
%else
Conflicts:	grubby < 6.0.24-3
%endif
Conflicts:	kmod < 7-2
Conflicts:	module-init-tools < 3.2.2-6
Conflicts:	pciutils < 2.2.9
Conflicts:	udev-initrd < 1:168
Conflicts:	xz < 4.999.9
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Geninitrd creates filesystem images for use as initial ramdisk
(initrd) images. These ramdisk images are often used to preload the
block device modules (SCSI or RAID) needed to access the root
filesystem.

In other words, generic kernels can be built without drivers for any
SCSI adapters which load the SCSI driver as a module. Since the kernel
needs to read those modules, but in this case it isn't able to address
the SCSI adapter, an initial ramdisk is used. The initial ramdisk is
loaded by the operating system loader (normally LILO) and is available
to the kernel as soon as the ramdisk is loaded. The ramdisk image
loads the proper SCSI adapter and allows the kernel to mount the root
filesystem. The geninitrd program creates such a ramdisk using
information found in the /etc/modules.conf file.

%description -l pl.UTF-8
Geninitrd służy do tworzenia obrazu systemu plikowego używanego jako
inicjalny ramdysk (initrd), z którego przy starcie systemu są ładowane
moduły kernela z obsługą urządzeń których obsługa nie jest
wkompilowana w kernel. Zazwyczaj modułami ładowanymi z inicjalnego
systemu plikowego są sterowniki SCSI, IDE czy też RAID po to żeby w
dalszej części inicjacji systemu był możliwy dostęp do głównego
systemu plikowego (root fs).

Dzięki initrd jest możliwe używanie dystrybucyjnego kernela w którym
wkompilowana jest minimalna ilość obsługi różnych urządzeń, a reszta
kodu obsługi sterowników SCSI, IDE czy RAID jest doczytywana w trakcie
startu z initrd. Skrypt geninitrd generuje obraz ramdysku na podstawie
bieżących informacji zawartych w /etc/modules.conf.

%prep
%setup -qc
mv %{name}-%{version}*/* .
%patch0 -p1

%build
%{__make}

%install
rm -rf $RPM_BUILD_ROOT
%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc ChangeLog
%config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/geninitrd
%attr(755,root,root) /sbin/geninitrd
%{_mandir}/man8/geninitrd.8*

%dir /lib/geninitrd
/lib/geninitrd/functions
/lib/geninitrd/mod-*.sh
%attr(755,root,root) /lib/geninitrd/extract-ikconfig

%dir /lib/geninitrd/udev-rules
/lib/geninitrd/udev-rules/*.rules
%changelog
* Sun Jun 28 2015 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/geninitrd.git;a=log;h=master

* Sun Jun 28 2015 Arkadiusz Miśkiewicz <arekm@maven.pl> 361d008
- rel 3; group for udev and yet another rootfs fallback

* Thu Mar 26 2015 Arkadiusz Miśkiewicz <arekm@maven.pl> 464ad04
- rel 2; libdir brokeness fixed

* Mon Mar 23 2015 Elan Ruusamäe <glen@delfi.ee> 8f10598
- up to 12749 (x32 fixes)

* Wed Feb 25 2015 Elan Ruusamäe <glen@delfi.ee> 1e38233
- modules are compressed with .xz on master branch

* Wed Nov 26 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> e4008f8
- rel 2; allow discard for LUKS devices

* Sat Nov 08 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> 240c97d
- up to 12744 (load font, antirace mdev, support for 3.18 compressed modules, load btrfs related modules when needed)

* Tue Oct 14 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> b66ea22
- rel 4; support for compressed modules used in 3.18.x kernels

* Mon Jun 09 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> c93f3d5
- rel 3; load font at initrd

* Wed May 14 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> ebc0b85
- rel 2; fix dmcrypt 'Udev cookie 0xd4dc311 (semid 229380) waiting for zero' problem

* Wed May 14 2014 Elan Ruusamäe <glen@delfi.ee> d322667
- up to 12736, fixes lvm on romfs boot issue

* Tue Apr 22 2014 Elan Ruusamäe <glen@delfi.ee> da72fe2
- require busybox with mdev support

* Fri Jan 31 2014 Jan Rękorajski <baggins@pld-linux.org> c6af255
- no *-initrd packages in Th now

* Sun Jan 05 2014 Elan Ruusamäe <glen@delfi.ee> c6fb106
- up to 12719; fixes initrd generation without lvm2-initrd package

* Sat Jul 20 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> 82f4458
- rel 3; load (hw optimized) crct10dif-pclmul, too

* Thu Jul 18 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> 1aab74e
- Rel 2. Preload crct10dif module when crc-t10dif is going to be loaded (uses its symbols without hard dependency).

* Tue Jul 02 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> 0d4a64b
- up to 12695

* Thu Apr 25 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> 2c7cc23
- rel 4; add ehci_platform; load xhci last

* Thu Apr 25 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> 7ba08d0
- rel 3; handle ehci-pci module

* Tue Apr 23 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> a19f276
- rel 2; virtio bus driver modules loading

* Thu Apr 18 2013 Marcin Krol <hawk@tld-linux.org> 35f9815
- dropped PLD Ti patches and %ifs

